import 'dart:convert';

import 'package:dashboard/JsonGetter.dart';
import 'package:enhanced_future_builder/enhanced_future_builder.dart';
import 'package:flutter/cupertino.dart';

import 'package:flutter/material.dart';
import 'shared.dart';
import 'usernode.dart';
import 'postnode.dart';

class UserGraph extends StatefulWidget {
  UserGraph(this.json);
  Map<String, dynamic> json;

  @override
  _UserGraphState createState() => _UserGraphState(json);
}

class _UserGraphState extends State<UserGraph> {
  _UserGraphState(this.user);
  final Map<String, dynamic> user;

  Widget build(BuildContext context) {
    return Container(
      //constraints: BoxConstraints.expand(),
      child: InteractiveViewer(
        constrained: true,
        boundaryMargin: EdgeInsets.all(100),
        minScale: 0.01,
        maxScale: 5.6,
        child: GraphView(
          graph: userGraph,
          algorithm: FruchtermanReingoldAlgorithm(),
          paint: Paint()
            ..color = Colors.green
            ..strokeWidth = 1
            ..style = PaintingStyle.stroke,
        ),
      ),
    );
  }

  final Graph userGraph = Graph();

  @override
  void initState() {
    super.initState();
    Map<String, dynamic> trustScores =
        user["trust_scores"] as Map<String, dynamic>;
    print(trustScores);
    final Node nodeUser = Node(UserNode(trustScores));
    userGraph.addNode(nodeUser);

    List<Map<String, dynamic>> postsUnpacked;
    Map<String, dynamic> postsByCommunity =
        user["posts"] as Map<String, dynamic>;
    postsByCommunity.forEach((community, posts) {
      for (var post in posts) {
        postsUnpacked.add(post) as Map<String, dynamic>;
      }
    });

    for (Map<String, dynamic> post in postsUnpacked) {
      Node nodePost = Node(PostNode(post));
      userGraph.addNode(nodePost);
      userGraph.addEdge(nodeUser, nodePost,
          paint: Paint()..color = Colors.black);
    }
  }
}

class UserGraphViewPage extends StatelessWidget {
  UserGraphViewPage(this.username);
  final String username;

  Widget build(BuildContext context) {
    return Scaffold(
        backgroundColor: Colors.white,
        body: Container(
          constraints: BoxConstraints.expand(),
          child: Column(
            mainAxisSize: MainAxisSize.max,
            children: [
              Wrap(
                children: [],
              ),
              EnhancedFutureBuilder(
                  future: JsonGetter.getJson(
                      "http://live.nope-api.systems:81/users/" +
                          username.toString()),
                  rememberFutureResult: false,
                  whenDone: (result) => UserGraph(result),
                  whenNotDone: Container(
                      alignment: Alignment.center, child: Text("loading..."))),
            ],
          ),
        ));
  }
}
